#include <code/query/boolean.hxx>

namespace code::query
{

  boolean_t::
  boolean_t(source_location_t origin, bool value)
    : origin_{move(origin)}, value_{value}
  {}

  source_location_t const&
  boolean_t::
  origin() const
  {
    return origin_;
  }

  bool
  boolean_t::
  value() const
  {
    return value_;
  }

  string
  to_string(boolean_t const& boolean)
  {
    return boolean.value() ? "true" : "false";
  }

} // namespace code::query
