#ifndef code__query__concepts_hxx_
#define code__query__concepts_hxx_

#include <code/query/source-location.hxx>
#include <code/query/types.hxx>

#include <concepts>

namespace code::query
{

  class expression_t;

  template<typename E>
  concept Expression = requires(E const& e)
  {
    { e.origin() } -> std::convertible_to<source_location_t>;

    { to_string(e) } -> std::convertible_to<string>;

  };

} // namespace code::query

#endif
