#ifndef code__query__parse_context_hxx_
#define code__query__parse_context_hxx_

#include <code/query/error.hxx>
#include <code/query/source-location.hxx>
#include <code/query/types.hxx>

namespace code::query
{

  class parse_context_t
  {
  public:
    parse_context_t();

    vector<warning_t> const&
    warnings() const;

    vector<error_t> const&
    errors() const;

    void
    report_warning(warning_t);

    void
    report_error(error_t);

  private:
    vector<warning_t> warnings_;
    vector<error_t> errors_;

  };

} // namespace code::query

#endif
